;
; dllimpl2.asm - Assembler code to be linked with DLLs (16 bit DOS version)
;

psp_maxpara	EQU	00002H			; offset into PSP
psp_environment	EQU	0002CH			; offset into PSP

		.MODEL	LARGE,C

		.CODE

cprog_psp	DW	?			; segment of PSP

cprog_dta	LABEL	DWORD
cprog_dta_off	DW	?
cprog_dta_seg	DW	?

dllasm_exit	PROC	USES BX DX ES

		CALL	unpatch_stuff

		MOV	AH,02FH			; Get DTA of "C" program
		INT	021H
		MOV	CS:[cprog_dta_off],BX	; keep for later
		MOV	CS:[cprog_dta_seg],ES

		MOV	AH,062H			; Get PSP segment in BX
		INT	021H
		MOV	CS:[cprog_psp],BX	; keep for later
		MOV	ES,BX
		MOV	DX,ES:[psp_maxpara]	; C6 is very nice since on
						; startup it sets bytes 2 and 3
						; to the last used paragraph
		SUB	DX,BX			; DX := no. of paras to keep

		MOV	AX,03100H		; Terminate and stay resident
						; Return code of 00
		INT	021H

dllasm_exit	ENDP

dllasm_deinit	PROC	USES BX CX DS ES

		MOV	ES,CS:[cprog_psp]	; get PSP
		MOV	BX,psp_environment
		MOV	ES,ES:[BX]		; get segment of environment
		MOV	AH,049H			; Free allocated memory
		INT	021H

		MOV	ES,CS:[cprog_psp]	; get PSP
		MOV	AH,049H			; Free allocated memory
		INT	021H

		RET

dllasm_deinit	ENDP

;
; Now some trickery.
; We wish to call _ctermsub to get vectors unpatched.
; _ctermsub returns with a RETN.
; So we must call it from the segment it resides in, ie: _TEXT.
; Also, MASM doesn't allow extrn _ctermsub:NEAR, CALL _ctermsub.
; So we'll make it FAR, call it as such, and drop the CS afterwards.
;

_TEXT		SEGMENT	'code'

unpatch_stuff	PROC	FAR

extrn _ctermsub:FAR
		CALL	_ctermsub		; closes down floating point
						; unpatches div 0 vector 000H
						; unpatches overlay vector 03FH
		POP	AX
		RET

unpatch_stuff	ENDP

_TEXT		ENDS

		END
