/*

dlluser.c - Code to be linked with  DLL users (16 bit DOS version)

*/

/*...sincludes:0:*/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <process.h>
#include <dos.h>
#include "dllimpl.h"
#include "dlluser.h"

/*...vdllimpl\46\h:0:*/
/*...vdlluser\46\h:0:*/
/*...e*/

DLL_EP dll_entrypoint(DLL *dll, const char *name, const char *args)
	{
	DLL_EXPORT *e = (DLL_EXPORT *) dll;
	int i;
	args=args; /* Not relevant on 16 bit DOS */
	for ( i = 0; e[i].name != NULL; i++ )
		if ( !strcmp(name, e[i].name) )
			return e[i].ep;
	return (DLL_EP) NULL;
	}	

DLL *dll_load(const char *name)
	{
	DLL_EXPORT *e = (DLL_EXPORT *) NULL;
	DLL_EXPORT **pe = &e;
	DLL *dll;
	DLL_EP ep_init;
	char cmd[20+1];
	char seg[20+1];
	char off[20+1];

	/* Execute the DLL program using spawnlp rather than system,
	   because system will not run anything but a .EXE, .COM or .BAT.
	   It also avoids the overhead of a new copy of COMMAND.COM. */
	strcpy(cmd, name);
	strcat(cmd, ".dll");
	itoa(FP_SEG(pe), seg, 10);
	itoa(FP_OFF(pe), off, 10);
	spawnlp(P_WAIT, cmd, name, "DOS-TSR-DLL", seg, off, NULL);

	if ( FP_SEG(e) == 0 )
		/* DLL program failed to run properly */
		return NULL;
	if ( FP_SEG(e) == 0xffff )
		/* It indicated a failure to us */
		return NULL;

	dll = (DLL *) e;

	ep_init = dll_entrypoint(dll, "_dll_init", "0");
	( (void (*)(void)) ep_init )();

	return dll;
	}

void dll_unload(DLL *dll)
	{
	DLL_EXPORT *e = (DLL_EXPORT *) dll;
	DLL_EP ep_term = dll_entrypoint(dll, "_dll_term", "0");
	( (void (*)(void)) ep_term )();
	}
