/*

dlluser.c - Code to be linked wit  DLL users (32 bit DOS version)

*/

/*...sincludes:0:*/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <dos.h>
#include "dllfunc.h"
#include "dllimpl.h"
#include "dlluser.h"

/*...vdllimpl\46\h:0:*/
/*...vdlluser\46\h:0:*/
/*...e*/

DLL_EP dll_entrypoint(DLL *dll, const char *name, const char *args)
	{
	void *handle = (void *) dll;
	char epname[1+100+1];
	args=args; /* Not relevant on 32 bit DOS */
	epname[0] = '_';
	strupr(strcpy(epname+1, name));
	return (DLL_EP) GetProcAddress(handle, epname);
	}

DLL *dll_load(const char *name)
	{
	char dllname[100+1+3+1];
	strcpy(dllname, name);
	strcat(dllname, ".dll");
	return (DLL *) LoadLibrary(dllname);
	}

void dll_unload(DLL *dll)
	{
	void *handle = (void *) dll;
	FreeLibrary(handle);
	}
