/*

dlluser.c - Code to be linked with DLL users (NetWare version)

*/

/*...sincludes:0:*/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <malloc.h>
#include <process.h>
#include <advanced.h>
#include <conio.h>
#include "dllimpl.h"
#include "dlluser.h"

/*...vdllimpl\46\h:0:*/
/*...vdlluser\46\h:0:*/
/*...e*/

typedef struct
	{
	unsigned nh;
	char name_term[1+100+5+1];
	} IDLL;

DLL_EP dll_entrypoint(DLL *dll, const char *name, const char *args)
	{
	IDLL *idll = (IDLL *) dll;
	DLL_EP ep = (DLL_EP) ImportSymbol(idll->nh, name);
	UnimportSymbol(idll->nh, name);
		/* Ensure reference count in DLL isn't left one higher. */
	args=args; /* Not relevant on NetWare */
	return ep;
	}

DLL *dll_load(const char *name)
	{
	char dllname[100+1+3+1];
	IDLL *idll;
	int ha, hc, rc;
	if ( (idll = (IDLL *) malloc(sizeof(IDLL))) == NULL )
		return (DLL *) NULL;
	strcpy(dllname, name);
	strcat(dllname, ".ndl");
	ha = GetCurrentScreen();
	if ( (hc = CreateScreen("System Console", 0)) == 0 )
		{
		free(idll);
		return (DLL *) NULL;
		}
	SetCurrentScreen(hc);
	rc = spawnlp(P_NOWAIT, dllname, dllname, NULL);
	SetCurrentScreen(ha);
	if ( rc < 0 )
		return (DLL *) NULL;
	idll->nh = FindNLMHandle(dllname);
	if ( idll->nh == 0 )
		{
		free(idll);
		return (DLL *) NULL;
		}
	sprintf(idll->name_term, "_%s_term", name);
	strlwr(idll->name_term);
	return (DLL *) idll;
	}

void dll_unload(DLL *dll)
	{
	IDLL *idll = (IDLL *) dll;
	DLL_EP ep_term = dll_entrypoint(dll, idll->name_term, "0");
	( (void (*)(void)) ep_term )();
	free(idll);
	}
