/*

dlluser.c - Code to be linked with  DLL users (32 bit OS/2 version)

*/

/*...sincludes:0:*/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#define	INCL_BASE
#include <os2.h>
#include "dllimpl.h"
#include "dlluser.h"

/*...vdllimpl\46\h:0:*/
/*...vdlluser\46\h:0:*/
/*...e*/

DLL_EP dll_entrypoint(DLL *dll, const char *name, const char *args)
	{
	HMODULE hmod = (HMODULE) dll;
	DLL_EP ep;
	args=args; /* Not relevant on OS/2 */
	return ( DosQueryProcAddr(hmod, 0, (char *) name, (PFN *) &ep) == 0 ) ? ep : (DLL_EP) NULL;
	}

DLL *dll_load(const char *name)
	{
	HMODULE hmod;
	CHAR x;
	return ( DosLoadModule(&x, 1, (char *) name, &hmod) == 0 ) ? (DLL *) hmod : (DLL *) NULL;
	}

void dll_unload(DLL *dll)
	{
	HMODULE hmod = (HMODULE) dll;
	DosFreeModule(hmod);
	}
