/*

progname.c - A sample program to use a DLL

*/

/*...sincludes:0:*/
#include <stdio.h>

#include "dlluser.h"

/*...vdlluser\46\h:0:*/
/*...e*/

int main(void)
	{
	DLL *dll;
	DLL_EP ep_sum, ep_product, ep_next, ep_outfile;
	int p;

	if ( (dll = dll_load("libname")) == NULL )
		{
		fprintf(stderr, "progname: can't load DLL libname\n");
		return 1;
		}

	if ( (ep_sum     = dll_entrypoint(dll, "sum"    , "8" )) == NULL ||
	     (ep_product = dll_entrypoint(dll, "product", "12")) == NULL ||
	     (ep_next    = dll_entrypoint(dll, "next"   , "0" )) == NULL ||
	     (ep_outfile = dll_entrypoint(dll, "outfile", "0" )) == NULL )
		{
		dll_unload(dll);
		fprintf(stderr, "progname: DLL libname doesn't have required entrypoints\n");
		return 2;
		}

	printf("sum of 1 and 2 is %d\n",
		( (int (DLL_EP_PTR)(int,int)) ep_sum )(1,2) );

	( (void (DLL_EP_PTR)(int,int,int *)) ep_product )(3,4,&p);
	printf("product of 3 and 4 is %d\n", p);

	printf("next returned %d\n", ( (int (DLL_EP_PTR)(void)) ep_next )() );
	printf("next returned %d\n", ( (int (DLL_EP_PTR)(void)) ep_next )() );
	printf("next returned %d\n", ( (int (DLL_EP_PTR)(void)) ep_next )() );

	p = ( (int (DLL_EP_PTR)(void)) ep_outfile )();
	printf("outfile returned %d\n", p);

	dll_unload(dll);
	return 0;
	}
